'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

var _glVec2Add = require('gl-vec2/add');

var _glVec2Add2 = _interopRequireDefault(_glVec2Add);

var _glVec2Multiply = require('gl-vec2/multiply');

var _glVec2Multiply2 = _interopRequireDefault(_glVec2Multiply);

var _glVec2Divide = require('gl-vec2/divide');

var _glVec2Divide2 = _interopRequireDefault(_glVec2Divide);

var _createCanvas = require('create-canvas');

var _createCanvas2 = _interopRequireDefault(_createCanvas);

var _drawToCanvas = require('draw-to-canvas');

var _drawToCanvas2 = _interopRequireDefault(_drawToCanvas);

var divideBy2 = function divideBy2(x) {
  return x / 2;
};

/**
 * resizes the resolutions of an html5 canvas element from a desired position
 * perserving the drawn image
 * @param  {element} canvas   an html5 canvas element
 * @param  {arr} diff      [width, height] to add to the current resolution
 * @param  {arr} fromPos      [x, y] postion to scale from
 * @return {element}          a new html5 canvas element
 */
function resizeCanvas(canvas, diff, fromPos) {
  if (diff === undefined) diff = [0, 0];

  var size = [canvas.width, canvas.height];
  var newSize = (0, _glVec2Add2['default'])([], size, diff);
  if (!fromPos) fromPos = size.map(divideBy2); // scale from center by default
  var drawOrigin = (0, _glVec2Multiply2['default'])([], (0, _glVec2Divide2['default'])([], fromPos, size), diff);
  return (0, _drawToCanvas2['default'])(canvas, _createCanvas2['default'].apply(undefined, _toConsumableArray(newSize)), drawOrigin);
}

exports['default'] = resizeCanvas;
module.exports = exports['default'];

